
(defcustom messages-stack-timeout 2
  "Number of seconds between messages before clearing the stack."
  :type 'number
  :group 'minibuffer
  :version "27.1")

(defcustom messages-stack-max 8
  "Max size of the message stack."
  :type 'number
  :group 'minibuffer
  :version "27.1")

(defvar messages-stack-separator "\n")

(defvar messages-stack nil)

(defun set-stacked-message (message)
  (let ((last-message (car messages-stack)))
    (unless (and last-message (equal message (aref last-message 1)))
      (when (and last-message (> (float-time) (+ (aref last-message 0)
                                                 messages-stack-timeout)))
        (setq messages-stack nil))
      (push (vector (float-time) message) messages-stack)
      (when (> (length messages-stack) messages-stack-max)
        (setf (nthcdr messages-stack-max messages-stack) nil)))
    (mapconcat (lambda (m) (aref m 1))
               (reverse messages-stack)
               messages-stack-separator)))

(setq set-message-function 'set-stacked-message)
